//Тест квадратурного энкодера, РадиоХобби №5-2013
//===================================================
#include <Encoder.h> //Библиотека функций энкодера
#define STEP 4 //Шаг для однощелчкового энкодера
//#define STEP 2 //Шаг для двухщелчкового энкодера
Encoder myEnc(11, 12); //Контакт "А" (D11), "В" (D12)
long oldNumber = -999; //Минимальное число
//===================================================
void setup() //Начальные настройки
{ Serial.begin(9600); //Скорость UART 9600 бод
  Serial.println("Start Encoder Test:"); //Заголовок
  pinMode(10, INPUT); //Кнопка энкодера - порт D10
} //=================================================
void loop() //Основная программа
{ long newNumber = myEnc.read() / STEP; //Усреднение
  if (newNumber != oldNumber) //Если был щелчок
  { oldNumber = newNumber; //Запомнить новое число
    Serial.println(newNumber); //Печать числа
  }
  if (digitalRead(10) == LOW) //Если кнопка нажата
  { delay(30); //Пауза "антидребезга" 30 мс
    if (digitalRead(10) == LOW) //Если кнопка нажата
    { Serial.println("Button!!!"); //Печать сообщения
      delay(300); //Пауза индикации 0,3 с
    }
  }    
} //Arduino-1.0.5, длина кода 4162 байтов

